<?php
set_time_limit(10);
$date=date("Y-m-d H:i:s");
require_once "./exel/class.writeexcel_workbook.inc.php";
require_once "./exel/class.writeexcel_worksheet.inc.php";
include "config.inc.php";
$search = $_REQUEST["search"];
if(!$_REQUEST["sort"]){
    $sort=0;
} else {
    $sort = $_REQUEST["sort"];
}
if (!$_REQUEST["table"]){
    $table="new_station";
} else {
    $table=$_REQUEST["table"];
}
switch ($sort){
    case 1:
        $order="hostname desc";
        break;
    case 2:
        $order="ip_address desc";
        break;
    case 3:
        $order="ethernet_address desc";
        break;
    case 4:
        $order="ethernet_vendor desc";
        break;
    case 5:
        $order="timestamp";
        break;
    case 6:
        $order="hostname";
        break;
    case 7:
        $order="ip_address";
        break;
    case 8:
        $order="ethernet_address";
        break;
    case 9:
        $order="ethernet_vendor";
        break;
    default:
        $order="timestamp desc";
        break;
}

$fname = tempnam("/tmp", "stocks.xls");
$workbook = &new writeexcel_workbook($fname);
$worksheet =& $workbook->addworksheet();

# Set the column width for columns 1, 2, 3 and 4
$worksheet->set_column(0, 2, 20);
$worksheet->set_column(3, 3, 40);
$worksheet->set_column(4, 4, 20);

if ($table=="changed_ethernet_address" || $table=="flip_flop"){
    $worksheet->set_column(5, 5, 40);
    $worksheet->set_column(6, 8, 20);
}

$worksheet->set_zoom(75);
# Create a format for the column headings
$header =& $workbook->addformat();
$header->set_size(10);
$header->set_color('red');

# Create a format for the stock price
$answer =& $workbook->addformat();
$answer->set_color('black');

# Write out the data
$worksheet->write(0, 0, 'hostname', $header);
$worksheet->write(0, 1, 'ip address', $header);
$worksheet->write(0, 2, 'ethernet address', $header);
$worksheet->write(0, 3, 'ethernet vendor', $header);
if ($table=="changed_ethernet_address" || $table=="flip_flop"){
    $worksheet->write(0, 4, 'old ethernet address', $header);
    $worksheet->write(0, 5, 'old ethernet vendor', $header);
    $worksheet->write(0, 6, 'timestamp', $header);
    $worksheet->write(0, 7, 'previous timestamp', $header);
    $worksheet->write(0, 8, 'delta', $header);
} else {
    $worksheet->write(0, 4, 'timestamp', $header);
}

if ($search) {
    if ($table=="new_station" || $table=="new_activity"){
        $result = mysql_query("select * from $table where hostname like '%$search%' || ip_address like '%$search%' || ethernet_address like '%$search%' || ethernet_vendor like '%$search%' || timestamp like '%$search%' order by $order");
    } else {
        $result = mysql_query("select * from $table where hostname like '%$search%' || ip_address like '%$search%' || ethernet_address like '%$search%' || old_ethernet_address like '%$search%' || ethernet_vendor like '%$search%' || old_ethernet_vendor like '%$search%' || timestamp like '%$search%' || previous_timestamp like '%$search%' order by $order");
    }
} else {
    $result = mysql_query("select * from $table order by $order");
}

if ($result){
    $rows = mysql_num_rows ( $result );
}
if ($rows){
    for ( $i=1; $i < $rows+1; $i++ ){
	$data = mysql_fetch_array( $result );
	$worksheet->write($i, 0, $data['hostname'], $answer);
	$worksheet->write($i, 1, $data['ip_address'], $answer);
	$worksheet->write($i, 2, $data['ethernet_address'], $answer);
	$worksheet->write($i, 3, $data['ethernet_vendor'], $answer);
	if ($table=="changed_ethernet_address" || $table=="flip_flop"){
	    $worksheet->write($i, 4, $data['old_ethernet_address'], $answer);
	    $worksheet->write($i, 5, $data['old_ethernet_vendor'], $answer);
	    $worksheet->write($i, 6, $data['timestamp'], $answer);
	    $worksheet->write($i, 7, $data['previous_timestamp'], $answer);
	    $worksheet->write($i, 8, $data['delta'], $answer);
	} else {
	    $worksheet->write($i, 4, $data['timestamp'], $answer);
	}
    }
}

$workbook->close();
header("Content-Type: application/x-msexcel; name=\"$table-$date.xls\"");
header("Content-Disposition: inline; filename=\"$table-$date.xls\"");

$fh=fopen($fname, "rb");
fpassthru($fh);
unlink($fname);

?>
